<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh-tw/HowTos/php7</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh-tw/HowTos/php7</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh-tw"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="A.2BVyg_CentOS_7.4_.2BTgpPf3Uo_PHP_7.x">在 CentOS 7.4 上使用 PHP 7.x</h1>
<span class="anchor" id="line-4"></span><p class="line874">此文章是關乎我近日所關注的一個問題：如何在 CentOS 7 預設的 httpd 伺服器上採用 PHP 7.0 或 7.1，卻不採用外置軟件庫或從源碼重新編譯 PHP？ <span class="anchor" id="line-5"></span><span class="anchor" id="line-6"></span><p class="line862">答案是 <strong>軟件選集</strong>。在這裡我們會從新的 CentOS 安裝開始，進而設立一個執行 PHP 7.x 的網站。 <span class="anchor" id="line-7"></span><span class="anchor" id="line-8"></span><p class="line874">首先，我們會安裝軟件選集的軟件庫（它是一個需要啟用的官方軟件庫）。 <span class="anchor" id="line-9"></span><span class="anchor" id="line-10"></span><p class="line867"><tt>root&nbsp;@&nbsp;centos7-vm:&nbsp;~&nbsp;#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;centos-release-scl.noarch</tt> <span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><p class="line874">此指令會在你的系統上部署一個新的軟件庫，它是 CentOS 的其中一個官方軟件庫。 <span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line874">安裝完成後，讓我們安裝 PHP 7 套件及 httpd 套件，連同它的插件。 <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line867"><tt>root&nbsp;@&nbsp;centos7-vm:&nbsp;~&nbsp;24&nbsp;#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;rh-php72&nbsp;rh-php72-php&nbsp;rh-php72-php-fpm&nbsp;httpd</tt> <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line862">為了要採用 php 7.2，我們將會使用 php-fpm，這是 <a class="https" href="https://wiki.apache.org/httpd/php">建議的做法</a>，並代替了 mod_php。既然如此，我們便採用 fpm 服務。此服務預設會在 900 埠上運行。要是你需要更改埠號，請開啟以下檔案： <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867"><tt>/etc/opt/rh/rh-php72/php-fpm.d/www.conf</tt> <span class="anchor" id="line-21"></span><span class="anchor" id="line-22"></span><p class="line874">然後將下行修改： <span class="anchor" id="line-23"></span><span class="anchor" id="line-24"></span><p class="line867"><tt>listen&nbsp;=&nbsp;127.0.0.1:9000</tt> <span class="anchor" id="line-25"></span><span class="anchor" id="line-26"></span><p class="line874">成為你所需的設定（例如：9002）。完成後，我們必須更改 selinux 的資料庫並加入 9002 為 httpd 服務的有效連接埠。 <span class="anchor" id="line-27"></span><span class="anchor" id="line-28"></span><p class="line867"><tt>semanage&nbsp;port&nbsp;-a&nbsp;-t&nbsp;http_port_t&nbsp;-p&nbsp;tcp&nbsp;9002</tt> <span class="anchor" id="line-29"></span><span class="anchor" id="line-30"></span><p class="line874">完成後，開啟 php-fpm 服務並在開機時啟動它： <span class="anchor" id="line-31"></span><span class="anchor" id="line-32"></span><p class="line874">{{{root @ centos7-vm: ~ 29 # systemctl enable rh-php72-php-fpm.service <span class="anchor" id="line-33"></span>Created symlink from /etc/systemd/system/multi-user.target.wants/rh-php72-php-fpm.service to /usr/lib/systemd/system/rh-php72-php-fpm.service. <span class="anchor" id="line-34"></span>root @ centos7-vm: ~ 30 # systemctl start rh-php72-php-fpm.service <span class="anchor" id="line-35"></span>root @ centos7-vm: ~ 31 # systemctl status rh-php72-php-fpm.service <span class="anchor" id="line-36"></span>● rh-php72-php-fpm.service - The PHP FastCGI Process Manager <span class="anchor" id="line-37"></span><ul><li style="list-style-type:none">Loaded: loaded (/usr/lib/systemd/system/rh-php72-php-fpm.service; enabled; vendor preset: disabled) <span class="anchor" id="line-38"></span>Active: active (running) since Thu 2019-11-07 01:04:34 UTC; 20min ago <span class="anchor" id="line-39"></span></li></ul><ul><li style="list-style-type:none">Main PID: 5202 (php-fpm) <span class="anchor" id="line-40"></span><ul><li style="list-style-type:none"><p class="line862">Status: &quot;Ready to handle connections&quot; <span class="anchor" id="line-41"></span>CGroup: /system.slice/rh-php72-php-fpm.service <span class="anchor" id="line-42"></span><ul><li style="list-style-type:none">├─30045 php-fpm: master process (/etc/opt/rh/rh-php72/php-fpm.conf) <span class="anchor" id="line-43"></span>├─30046 php-fpm: pool www <span class="anchor" id="line-44"></span>├─30047 php-fpm: pool www <span class="anchor" id="line-45"></span>├─30048 php-fpm: pool www <span class="anchor" id="line-46"></span>├─30049 php-fpm: pool www <span class="anchor" id="line-47"></span>└─30050 php-fpm: pool www}}} <span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span></li></ul></li></ul></li></ul><p class="line874">現在我們須要設定 httpd 背景服務並告訢它利用此服務來處理 php 頁面。 <span class="anchor" id="line-50"></span><span class="anchor" id="line-51"></span><p class="line862">讓我們在 <tt>/etc/httpd/conf.d/</tt> 資料來建立名為 <tt>fpm.conf</tt> 的檔案，並放入以下內容： <span class="anchor" id="line-52"></span><span class="anchor" id="line-53"></span><p class="line874">{{{# PHP scripts setup <span class="anchor" id="line-54"></span><a class="nonexistent" href="./ProxyPassMatch.html">ProxyPassMatch</a> ^/(.*.php)$ fcgi://127.0.0.1:9000/var/www/html <span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><p class="line874">Alias / /var/www/html/ <span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><p class="line867"><a class="nonexistent" href="./DirectoryIndex.html">DirectoryIndex</a> index.php}}} <span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><p class="line874">如此，apache 將會把所有以 .php 結尾的檔案傳送到我們的 php-fpm 服務，然後顯示所得結果。 <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><p class="line874">為要確定一切正常，我們會在 /var/www/html 建立一個小頁面，提出 phpinfo 的要求 <span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><p class="line874">{{{root @ centos7-vm: ~ 1 # cat /var/www/html/index.php <span class="anchor" id="line-65"></span>&lt;?php phpinfo() ?&gt; <span class="anchor" id="line-66"></span>root @ centos7-vm: ~ 1 #}}} <span class="anchor" id="line-67"></span><span class="anchor" id="line-68"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> 切勿忘記這只是一個基本設置來確定你的安裝能運作。如果你需要實際應用於程式中，你或許應參考 <a class="https" href="https://developers.redhat.com/blog/2017/10/25/php-configuration-tips/">此文章</a> 調校你的 php 設定。 <span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><p class="line874">請勿忘記起動、啟用及加入你的 httpd 服務到防火牆： <span class="anchor" id="line-71"></span><span class="anchor" id="line-72"></span><p class="line874">{{{root @ centos7-vm: ~ 43 # systemctl enable httpd ; systemctl start httpd <span class="anchor" id="line-73"></span>root @ centos7-vm: ~ 46 # firewall-cmd --add-service=http --permanent <span class="anchor" id="line-74"></span>success <span class="anchor" id="line-75"></span>root @ centos7-vm: ~ 47 # firewall-cmd --reload <span class="anchor" id="line-76"></span>success}}} <span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><p class="line874">現在我們若連線到該網站，它會顯示 php 已被正確地處理： <span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><p class="line867"><img alt="HowTos/php7/phpinfo7.0.png" class="attachment" src="attachments/HowTos(2f)php7/phpinfo7.0.png" title="HowTos/php7/phpinfo7.0.png" /> <span class="anchor" id="line-81"></span><span class="anchor" id="line-82"></span><p class="line867"><small>Translation of revision 7</small> <span class="anchor" id="line-83"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
